/*******************************************************************************************************************************************
 *     						  																		   *
 * : " ", , . .      																		                   *
 * :  ..              																						   *
*******************************************************************************************************************************************/ 


// Init
#define DDR_Init DDRE
#define PORT_Init PORTE
#define P_Init 7
#define PIN_Init (PINB&(1<<P_Init))

//  ""
#define DDR_Led_Red DDRG
#define PORT_Led_Red PORTG
#define P_Led_Red 4

#define LED_RED_OFF PORT_Led_Red &= ~(1<<P_Led_Red)							//  
#define LED_RED_ON PORT_Led_Red |= (1<<P_Led_Red)							//  
#define LED_RED_TUGGLE PORT_Led_Red ^= (1<<P_Led_Red)							//  

//    EEPROM
#define E_COIL_START 0x0000													//  EEPROM

//  Modbus
#define S_COIL_START 0														//  DO
#define S_COIL_NREGS 0														//  DO

#define S_DISCRETE_INPUT_START 0											//  DI
#define S_DISCRETE_INPUT_NREGS 0											//  DI

#define S_REG_INPUT_START 0													//  AI
#define S_REG_INPUT_NREGS 0x100													//  AI

#define S_REG_HOLDING_START 0x0000											//  AO
#define S_REG_HOLDING_NREGS 0x100											//  AO

#define INREG_MID_TEMP 10
#define INREG_SKO 11

#define INREG_SLAVE_DATA_0 0
#define INREG_SLAVE_DATA_1 1
#define INREG_SLAVE_DATA_2 2
#define INREG_SLAVE_DATA_3 3
#define INREG_SLAVE_DATA_4 4
#define INREG_SLAVE_DATA_5 5
#define INREG_SLAVE_DATA_6 6
#define INREG_SLAVE_DATA_7 7
#define INREG_DATA_8 8
#define INREG_DATA_9 9

#define INREG_SLAVE_STAT_0 12
#define INREG_SLAVE_STAT_1 13
#define INREG_SLAVE_STAT_2 14
#define INREG_SLAVE_STAT_3 15
#define INREG_SLAVE_STAT_4 16
#define INREG_SLAVE_STAT_5 17
#define INREG_SLAVE_STAT_6 18
#define INREG_SLAVE_STAT_7 19

#define INREG_STAT_8 20
#define INREG_STAT_9 21

#define INREG_SLAVE_DATA_FL_0 30
#define INREG_SLAVE_DATA_FL_1 32
#define INREG_SLAVE_DATA_FL_2 34
#define INREG_SLAVE_DATA_FL_3 36
#define INREG_SLAVE_DATA_FL_4 38
#define INREG_SLAVE_DATA_FL_5 40
#define INREG_SLAVE_DATA_FL_6 42
#define INREG_SLAVE_DATA_FL_7 44
#define INREG_SLAVE_DATA_FL_8 46
#define INREG_SLAVE_DATA_FL_9 48
#define INREG_SLAVE_DATA_FL_MID 50
#define INREG_SLAVE_DATA_FL_SKO 52
/* 
*   
*   
*  IO 1
*  IO 2
*  IO 3
* VER SW
*/
#define BASE_DEFAULT	usSRegHoldBuf[REG_MODUL_TYPE_DETECT_NEW] = MODUL_TYPE_DETECT_NEW;\
						usSRegHoldBuf[REG_MODUL_VERSION_0] = version[0]<<8 | version[1];\
						usSRegHoldBuf[REG_MODUL_VERSION_1] = version[2]<<8 | version[3];\
						usSRegHoldBuf[REG_MODUL_VERSION_2] = version[4]<<8 | version[5];\
						usSRegHoldBuf[REG_MODUL_VERSION_3] = version[6]<<8 | version[7]

#define MODUL_DEFAULT			0x5253										//       "RS"
#define MODUL_PROGRAM_RESET		0x524D										//      "RM"
